# -*- coding: utf-8 -*-
"""Assist.org web scraping.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1YEt2OeKZ0ebDQSWlVZwFIX1I7amWSd9Q
"""

!pip install selenium
!apt-get update # to update ubuntu to correctly run apt install
!apt install chromium-chromedriver
!cp /usr/lib/chromium-browser/chromedriver /usr/bin

import selenium
from selenium import webdriver
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from bs4 import BeautifulSoup

import os
import requests
import re
from bs4 import BeautifulSoup
from http.client import responses
import io
import time

from selenium.webdriver.support.ui import Select
'''
download all pdf files based on code number. E.g. 26280690 to 26281190
'''
pdf_urls = []
code = []
for i in range(26280690,26281190):
  pdf_urls.append('https://assist.org/transfer/report/' + str(i))
  code.append(i)

chrome_options = webdriver.ChromeOptions()
chrome_options.add_argument('--headless')
chrome_options.add_argument('--no-sandbox')
chrome_options.add_argument('--disable-dev-shm-usage')
chrome_options.add_experimental_option('prefs', {
"download.default_directory": "/content/pdf/", #Change default directory for downloads
"download.prompt_for_download": False, #To auto download the file
"download.directory_upgrade": True,
"plugins.always_open_pdf_externally": True #It will not show PDF directly in chrome
})

wd = webdriver.Chrome(options=chrome_options)

''' Download pdf files by multithreading '''
def download_pdf_from_report_link(report_link, code):
  wd.get(report_link)
  time.sleep(1)

from concurrent.futures import ThreadPoolExecutor
from multiprocessing import cpu_count

workers = cpu_count()
with ThreadPoolExecutor(max_workers=workers) as executor:
  try:
    executor.map(download_pdf_from_report_link, pdf_urls, code)
  except:
    pass

''' change all file names to standard pattern '''
def get_pdf_name_from_file(location):
  raw = parser.from_file(location)
  pdf_content = raw['content']
  From_school = pdf_content.split('From:')[1].split('\n')[0].strip()
  To_school = pdf_content.split('To:')[1].split('\n')[0].strip()
  Year = pdf_content.split('Academic Year')[0][-10:].strip()
  Major = pdf_content.split('Academic Year')[1].split('\n\n')[1].strip()
  return From_school, To_school, Year, Major

import glob
import os


for i in glob.glob("/content/pdf/*.pdf"):
  try:
    From_school, To_school, Year, Major = get_pdf_name_from_file(i)
    os.rename(i, '/content/pdf/' + str(Year) + ' From: ' +str(From_school) + 'To: ' + str(To_school) + ' '+ str(Major) + '.pdf')
  except:
    print(i)

! pip install tika

from tika import parser # pip install tika

''' scrape course information from pdf files and build them into a dictionary'''
def get_school_courses(location): # location is the pdf file location
  raw = parser.from_file(location)
  pdf_content = raw['content']

  right_school_courses = []
  for i in range(0, len(pdf_content.split('←'))):
    course = pdf_content.split('←')[i].replace('\u200b', '').split('\n')[0].strip()
    if course.find('Articulate') != -1:
      pass
    elif course == '':
      pass
    else:
      right_school_courses.append(course)
    right_school_courses = list(set(right_school_courses))

  left_school_courses = []
  for i in range(0, len(pdf_content.split('←'))):
    course = pdf_content.split('←')[i].replace('\u200b', '').split('\n')[-1].strip()
    if course.find('Articulate') != -1:
      pass
    elif course == '':
      pass
    else:
      left_school_courses.append(course)
    left_school_courses = list(set(left_school_courses))

  return right_school_courses, left_school_courses

def course_dict(location):
  From_school, To_school, Year, Major = get_pdf_name_from_file(location)
  right_school_courses, left_school_courses = get_school_courses(location)
  return {From_school: right_school_courses, To_school: left_school_courses}

course_dict('/content/2022-2023 From_ Allan Hancock CollegeTo_ University of California, Davis Aerospace Science & Engineering B.S.pdf')






''' Belows are getting school name, major, year information from website, not from the pdf file. '''
def get_pdf_name(assist_url):
  '''assist_url is the assist.org page. e.g. https://assist.org/transfer/results?year=73&institution=27&agreement=143&agreementType=to&view=agreement '''
  global wd
  
  wd.get(assist_url)
  time.sleep(2)
  year = wd.find_element(By.CLASS_NAME, "resultYear").text
  year = year.split()[2]
  major = wd.find_element(By.CLASS_NAME, "resultTitle").text
  major = major.split('\n')[0]
  school = wd.find_element(By.CLASS_NAME, "resultCollege").text
  return '{year}, {major}, {school}.pdf'.format(year = year, major = major, school = school)

def download_pdf(assist_url):
  global wd

  chrome_options = webdriver.ChromeOptions()
  chrome_options.add_argument('--headless')
  chrome_options.add_argument('--no-sandbox')
  chrome_options.add_argument('--disable-dev-shm-usage')

  pdf_name = get_pdf_name(assist_url)
  print(pdf_name)

  chrome_options.add_experimental_option('prefs', {
  "download.default_directory": "/content/{pdf_name}".format(pdf_name=pdf_name), #Change default directory for downloads
  "download.prompt_for_download": False, #To auto download the file
  "download.directory_upgrade": True,
  "plugins.always_open_pdf_externally": True #It will not show PDF directly in chrome
  })
  wd = webdriver.Chrome(options=chrome_options)

  wd.get('https://assist.org/transfer/report/' + str(assist_url.split('major&viewByKey=')[1]))
  time.sleep(2)

start, end = 25897950, 25897970
for i in range(start, end):
    assist_url = "https://assist.org/transfer/results?year=72&institution=121&agreement=11&agreementType=to&view=agreement&viewBy=major&viewByKey=" + str(i)
    try:
      download_pdf(assist_url)
    except:
      print(i,'No accessible page')

